/*******************************************************************************
FILE : view_control.h

LAST MODIFIED : 21 January 1995

DESCRIPTION :
Interfaces the view widget to the 3-D graphics window.  At present it creates a
separate shell for the view widget.
==============================================================================*/
/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is cmgui.
 *
 * The Initial Developer of the Original Code is
 * Auckland Uniservices Ltd, Auckland, New Zealand.
 * Portions created by the Initial Developer are Copyright (C) 2005
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */
#if !defined (VIEW_CONTROL_H)
#define VIEW_CONTROL_H

#include "graphics/graphics_window.h"

/*
Global types
------------
*/
struct View_control
/*******************************************************************************
LAST MODIFIED : 21 January 1995

DESCRIPTION :
Contains information required by the camera control dialog.
==============================================================================*/
{
	Widget widget_parent,widget;
	Widget view_widget;
	struct Graphics_window *graphics_window;
}; /* struct View_control */

/*
Global functions
----------------
*/
struct View_control *create_View_control(Widget parent,
	struct Graphics_window *graphics_window);
/*******************************************************************************
LAST MODIFIED : 21 January 1995

DESCRIPTION :
Creates a view widget, a shell around the view widget (with the specified
<parent>) and sets the callbacks for the view widget to interface with the
<graphics_window>.
==============================================================================*/
#endif
