function GraphView(id)
{
  this.id = id;
  return this;
}

GraphView.prototype =
{
  QueryInterface: function(i)
  {
    if (iid.equals(Components.interfaces.nsISupports) ||
        iid.equals(Components.interfaces.nsISupportsWeakReference) ||
        iid.equals(Components.interfaces.nsIDOMEventListener))
      return this;
    return Components.results.NS_ERROR_NO_INTERFACE;
  },

  handleEvent : function(aEvent)
  {
    var newvis = this.panel.getAttribute('onscreen');
    newvis = (newvis == "true");
    if (newvis && !this.visible)
    {
      var gbs = this.panel.getElementsByTagName("groupbox");
      var ep = gbs.item(0);
      this.embed =
        ep.getElementsByTagNameNS("http://www.w3.org/1999/xhtml", "embed").item(0);
      var x = this;
      setTimeout(function ()
                 {
                   x.embed = x.embed.QueryInterface(Components.interfaces.mozIGeneralPlugin);
                   SetupEmbed(x, x.irw);
                 }, 0);
    }
    this.visible = newvis;
  },

  setPanel: function(x)
  {
    this.panel = x;
    this.panel.addEventListener("DOMAttrModified", this, false);
    this.visible = true;
    var gbs = x.getElementsByTagName("groupbox");
    this.embed =
      gbs.item(0).getElementsByTagNameNS("http://www.w3.org/1999/xhtml", "embed").item(0)
         .QueryInterface(Components.interfaces.mozIGeneralPlugin);
    var gb2 = gbs.item(1).QueryInterface(Components.interfaces.nsIDOMElement);
    this.tree = gb2.getElementsByTagName("tree").item(0)
                   .QueryInterface(Components.interfaces.nsIDOMElement);
    this.label = gb2.getElementsByTagName("label").item(0)
                   .QueryInterface(Components.interfaces.nsIDOMElement);
    var hb = gb2.getElementsByTagName("hbox").item(0)
                .QueryInterface(Components.interfaces.nsIDOMElement);
    this.checkbox = hb.getElementsByTagName("checkbox").item(0)
                      .QueryInterface(Components.interfaces.nsIDOMElement);
    this.picker = hb.getElementsByTagName("colorpicker").item(0)
                    .QueryInterface(Components.interfaces.nsIDOMElement);

    // Tree columns now need a unique identifier...
    var tc = this.tree.getElementsByTagName("treecols").item(0)
        .QueryInterface(Components.interfaces.nsIDOMElement)
        .getElementsByTagName("treecol");

    var i = 0;
    for (i = 0; i < tc.length; i++)
      tc.item(i).setAttribute("id", "treecol_" + (window.treecol_id++));
  },

  setupTree: function(irw)
  {
    this.show = new Array();
    this.imports = new Array();

    this.rdfsource =
      Components.classes["@mozilla.org/rdf/datasource;1?name=in-memory-datasource"]
                .createInstance(Components.interfaces.nsIRDFDataSource);

    this.rdfvarcont =
      window.rdfcu.MakeSeq(this.rdfsource, window.rdfvar);

    var rs = this.rdfsource;

    for (i = 0; i < window.nvariables; i++)
    {
      this.show[i] = true;
      var v = window.variables[i];

      var varRDF = window.varres[i];

      rs.Assert
      (
       varRDF,
       window.rdfname,
       window.varnameres[i],
       true
      );
      rs.Assert
      (
       varRDF,
       window.rdftype,
       window.vartyperes[i],
       true
      );
      rs.Assert
      (
       varRDF,
       window.rdfvisible,
       window.rdfyes,
       true
      );
      rs.Assert
      (
       varRDF,
       window.rdfproperty,
       window.varprops[i],
       true
      );
      rs.Assert
      (
       varRDF,
       window.rdfindex,
       window.rdfserv.GetIntLiteral(i),
       true
      );

      if (window.useTreeLayout)
      {
        var imp = AddOrGetImport(this, v.importNumber);
        var comp = imp.addOrGetComponent(v.componentName);
        comp.AppendElement(varRDF);
      }
      else
        this.rdfvarcont.AppendElement(varRDF);
    }
    this.tree.database.AddDataSource(this.rdfsource);
    this.tree.builder.rebuild();
  }
};

function GetActiveGraphView()
{
  var tb = document.getElementById("graph_tabbox");
  return window.graphviews[tb.selectedIndex];
}

function ShowAllVariables()
{
  if (window.waiting_sv_ready)
    return;
  var strb = document.getElementById("mozcellml-string-bundle");
  var i;
  var gv = GetActiveGraphView();
  gv.checkbox.checked = true;
  for (i = 0; i < window.nvariables; i++)
  {
    var oldValue = gv.rdfsource.GetTarget(window.varres[i], window.rdfvisible, true);
    gv.rdfsource.Unassert(window.varres[i], window.rdfvisible, oldValue);
    gv.rdfsource.Assert(window.varres[i], window.rdfvisible, window.rdfyes, true);
    gv.show[i] = true;
    CmguiSetVariableVisibility(gv.id, i, true);
  }
}

function HideAllVariables()
{
  if (window.waiting_sv_ready)
    return;
  var strb = document.getElementById("mozcellml-string-bundle");
  var i = 0;
  var gv = GetActiveGraphView();
  gv.checkbox.checked = false;
  for (i = 0; i < window.nvariables; i++)
  {
    var oldValue = gv.rdfsource.GetTarget(window.varres[i], window.rdfvisible, true);
    gv.rdfsource.Unassert(window.varres[i], window.rdfvisible, oldValue);
    gv.rdfsource.Assert(window.varres[i], window.rdfvisible, window.rdfno, true);
    gv.show[i] = false;
    CmguiSetVariableVisibility(gv.id, i, false);
  }
}

function OnXSlide()
{
  if (window.waiting_sv_ready)
    return;
  var slider = document.getElementById("xpos-scroll");
  var box = document.getElementById("xpos");
  box.value = slider.getAttribute("curpos") *
              window.arguments[0].gridx +
              window.arguments[0].startx;
  GetXAtTime(slider.getAttribute("curpos"));
  return true;
}

function OnXTextChange()
{
  if (window.waiting_sv_ready)
    return;
  var slider = document.getElementById("xpos-scroll");
  var box = document.getElementById("xpos");
  slider.setAttribute("curpos",
                      Math.floor((box.value - window.arguments[0].startx) /
                                 window.arguments[0].gridx));
  GetXAtTime(slider.getAttribute("curpos"));
  return true;
}

function CancelIntegrationWindow()
{
  if (window.irw != null)
  {
    window.irw.commandData = null;
    window.irw = null;
  }
  window.zincFeeder = null;
  window.arguments[0].closed = true;

  if (!window.arguments[0].live)
    return;
  if (window.arguments[0].mainwin.integrator != null)
  {
    ChangeIntegratorButtons(window.arguments[0].maindoc, true, false);
    window.arguments[0].mainwin.integrator.suspend();
  }
}

function PrepareIntegrationWindow()
{
  var irw = window.arguments[0];
  window.waiting_sv_ready = 1;
  window.irw = irw;

  window.treecol_id = 1;
  window.style_id = 1;

  window.useTreeLayout = GetVariableTreePref();

  // Set up the graph views array to match the tab panel...
  window.graphviews = new Array();
  window.graphviews[0] = new GraphView(0);
  window.graphviews[0].tab = document.getElementById("graph_tabs")
                                     .getElementsByTagName("multitab").item(0);

  window.colourstyles = new Array();

  irw.meter = document.getElementById("integration-progress");
  irw.meter.setAttribute("value",
      ((window.arguments[0].curpoint / window.arguments[0].npoints) * 100));

  window.model = window.arguments[0].model;

  var de = document.documentElement;
  var title = window.model.title + " - " + de.getAttribute("title");
  de.setAttribute("title", title);

  window.variables = irw.variables;
  window.nvariables = irw.nvariables;

  var rdfserv = Components.classes["@mozilla.org/rdf/rdf-service;1"]
                          .getService(Components.interfaces.nsIRDFService);
  window.rdfserv = rdfserv;
  var rdfcu = Components.classes['@mozilla.org/rdf/container-utils;1']
                        .getService(Components.interfaces.nsIRDFContainerUtils);
  window.rdfcu = rdfcu;

  window.rdfname
    = rdfserv.GetResource("http://www.physiome.org/rdf/mozCellML#variableName");
  window.rdftype
    = rdfserv.GetResource("http://www.physiome.org/rdf/mozCellML#variableType");
  window.rdfvisible
    = rdfserv.GetResource("http://www.physiome.org/rdf/mozCellML#variableVisible");
  window.rdfproperty
    = rdfserv.GetResource("http://www.physiome.org/rdf/mozCellML#variableProperty");
  window.rdfindex =
    rdfserv.GetResource("http://www.physiome.org/rdf/mozCellML#variableIndex");
  window.rdfvar =
    rdfserv.GetResource("http://www.physiome.org/rdf/mozCellML#all-variables");

  var strb = document.getElementById("mozcellml-string-bundle");
  var rdfyes = rdfserv.GetLiteral(strb.getString("yes"));
  window.rdfyes = rdfyes;
  window.rdfno = rdfserv.GetLiteral(strb.getString("no"));

  window.colours = irw.colour;
  window.varres = new Array();
  window.varnameres = new Array();
  window.vartyperes = new Array();
  window.varprops = new Array();
  window.max_graph_id = 1;

  for (i = 0; i < window.nvariables; i++)
  {
    var varRDF = rdfserv.GetAnonymousResource();
    window.varres[i] = varRDF;
    window.varnameres[i] = rdfserv.GetLiteral(window.variables[i].name);
    window.vartyperes[i] = rdfserv.GetLiteral(TypeToString(window.variables[i].type));
    window.varprops[i] = rdfserv.GetLiteral("colourvar" + i);
    var colourRule = "::-moz-tree-cell(colourvar" + i + ") {" +
                     "background-color: " + ascolour(window.colours[i]) + ";" +
                     "}";

    var ss = document.styleSheets.item(0)
                     .QueryInterface(Components.interfaces.nsIDOMCSSStyleSheet);
    var ri = ss.insertRule(colourRule, ss.cssRules.length);
    window.colourstyles[i] =  ri;
  }

  var slider = document.getElementById("xpos-scroll");
  var xbox = document.getElementById("xpos");
  slider.setAttribute("maxpos",
                      (window.arguments[0].stopx - window.arguments[0].startx) /
                      window.arguments[0].gridx);
  xbox.value = window.arguments[0].startx;
  var i = 0;
  var nv = window.nvariables;

  // Setup the graphview...
  var tp1 =
    document.getElementById("graph_tabpanels").getElementsByTagName("multitabpanel")
            .item(0).QueryInterface(Components.interfaces.nsIDOMElement);
  window.graphviews[0].setPanel(tp1);
  window.graphviews[0].setupTree(irw);

  var boundname = document.getElementById("boundname");
  boundname.value = irw.bound;
  var boundunit = document.getElementById("boundunit");
  boundunit.value = irw.boundunit;
  irw.p = window.graphviews[0].embed.QueryInterface
    (
     Components.interfaces.mozIGeneralPlugin
    );

  window.graphviews[0].irw = irw;
  SetupEmbed(window.graphviews[0], irw);
}

function GetXAtTime(ti)
{
  if (window.waiting_sv_ready)
    return;
  var strb = document.getElementById("mozcellml-string-bundle");
  var statusBar = document.getElementById("status-bar-display");
  if (ti < 0)
  {
    statusBar.label = strb.getString("beforeFirstPoint");
    document.getElementById("value-at-x").value = "";
    return;
  }

  var gv = GetActiveGraphView();
  var idx = GetRDFIndexFromTree(gv, gv.tree);
  if (idx == -1)
  {
    statusBar.label = strb.getString("selectVariableFirst");
    document.getElementById("value-at-x").value = "";
    return;
  }

  var data;
  try
  {
    data = window.zincFeeder.getValue(idx, ti);
  }
  catch (e)
  {
    alert(e);
    statusBar.label = strb.getString("noDataAtPoint");
    document.getElementById("value-at-x").value = "";
    return;
  }

  document.getElementById("value-at-x").value = data;
  statusBar.label = strb.getString("valueRetrieved");
}

function SelectIntegrationVariable()
{
  if (window.waiting_sv_ready)
    return;

  var gv = GetActiveGraphView();

  var idx = GetRDFIndexFromTree(gv, gv.tree);
  if (idx < 0)
    return;

  var name = window.variables[idx].name;
  gv.label.value = name;
  document.getElementById("variable-unit").value = window.variables[idx].units;
  gv.checkbox.checked = gv.show[idx];
  var col = ascolour(window.arguments[0].colour[idx]);
  gv.picker.color = col;
  GetXAtTime(document.getElementById("xpos-scroll").getAttribute("curpos"));
  return true;
}

function ChangeGraphColour()
{
  if (window.waiting_sv_ready)
    return;
  var gv = GetActiveGraphView();
  var idx = GetRDFIndexFromTree(gv, gv.tree);
  if (idx < 0)
    return;
  var colour = gv.picker.color;
  var col = window.arguments[0].colour[idx] = colourtonumber(colour);
  var colourRule = "::-moz-tree-cell(colourvar" + idx + ") {" +
                   "background-color: " + colour + ";" +
                     "}";

  var ss = document.styleSheets.item(0)
                   .QueryInterface(Components.interfaces.nsIDOMCSSStyleSheet);
  ss.deleteRule(window.colourstyles[idx]);
  var ri = ss.insertRule(colourRule, window.colourstyles[idx]);
  // gv.tree.builder.rebuild();
  // gv.tree.view.setCellText(box.view.selection.currentIndex, "colour", "");

  var red = col & 0xFF, green = (col >> 8) & 0xFF, blue = (col >> 16) & 0xFF;
  CmguiSetVariableColour(idx, red, green, blue);
  return true;
}

function ChangeDraw()
{
  if (window.waiting_sv_ready)
    return;
  var strb = document.getElementById("mozcellml-string-bundle");
  var gv = GetActiveGraphView();
  var box = gv.tree;
  var treeidx = box.view.selection.currentIndex;
  var builder = box.view.QueryInterface(Components.interfaces.nsIXULTreeBuilder);
  var resource = builder.getResourceAtIndex(treeidx);
  var idx = gv.rdfsource.GetTarget(resource, window.rdfindex, true)
                  .QueryInterface(Components.interfaces.nsIRDFInt).Value;

  if (idx < 0)
    return;
  var draw = gv.checkbox.checked;
  gv.show[idx] = draw;

  var oldValue = gv.rdfsource.GetTarget(resource, window.rdfvisible, true);
  gv.rdfsource.Unassert(resource, window.rdfvisible, oldValue);
  gv.rdfsource.Assert(resource, window.rdfvisible,
                          draw ? window.rdfyes : window.rdfno, true);
  CmguiSetVariableVisibility(gv.id, idx, draw);
  return false;
}

function CloneAtTime()
{
  if (window.waiting_sv_ready)
    return;
  var ti = document.getElementById("xpos-scroll").getAttribute("curpos");
  var statusBar = document.getElementById("status-bar-display");
  var strb = document.getElementById("mozcellml-string-bundle");
  if (ti < 0)
  {
    statusBar.label = strb.getString("beforeFirstPoint");
    return;
  }
  if (ti >= window.arguments[0].npoints)
  {
    statusBar.label = strb.getString("noDataAtPoint");
    return;
  }
  var olddom = window.model.QueryInterface(Components.interfaces.mozICellMLLocal).DOM;
  var newdom = olddom.cloneNode(true);
  newdom =  newdom.QueryInterface(Components.interfaces.nsIDOMDocument);
  statusBar.label = strb.getString("copyingModel");
  var newmodel = Components.classes["@physiome.org/mozCellML;1"]
                  .createInstance(Components.interfaces.mozICellML);
  var strb = document.getElementById("mozcellml-string-bundle");
  if (window.translationset == null)
  {
    window.translationset =
      Components.classes["@physiome.org/TranslationSet;1"]
                .createInstance(Components.interfaces.mozITranslationSetLocal);
    window.translationset.bundle = strb.stringBundle;
    window.translationset = window.translationset.QueryInterface(Components.interfaces.mozITranslationSet);
  }
  newmodel.setStringBundle(window.translationset);
  newmodel.QueryInterface(Components.interfaces.mozICellMLLocal).DOM = newdom;
  newmodel.initialise();
  var i;
  statusBar.label = strb.getString("copyingVariables");
  for (i = 0; i < window.nvariables; i++)
  {
    try
    {
      // Throw an exception if no initial value...
      var x = window.variables[i].initialValue;
      newmodel.getVariable(window.variables[i].name,
                           window.variables[i].componentName).initialValue =
        window.zincFeeder.getValue(i, ti);
    }
    catch (e)
    {
      // If there was no initial value before, we don't want one now.
    }
  }
  statusBar.label = strb.getString("creatingWindow");
  window.arguments[0].integrator.want();
  window.openDialog(
                    "chrome://mozcellml/content/modelview.xul",
                    "_blank",
                    "chrome,dialog=no",
                    newmodel,
                    window.arguments[0].integrator
                   );
  statusBar.label = strb.getString("modelCloned");
}

function SelectLocalExport(returnto)
{
  var strb = document.getElementById("mozcellml-string-bundle");
  try
  {
    const nsIFilePicker = Components.interfaces.nsIFilePicker;
    var fp = Components.classes["@mozilla.org/filepicker;1"]
                       .createInstance(nsIFilePicker);
    fp.init(window, strb.getString("chooseCSVExportFilename"),
            nsIFilePicker.modeSave);
    fp.appendFilter("CSV", "*.csv");
    fp.appendFilter(strb.getString("textFiles"), "*.txt");
    fp.appendFilter(strb.getString("allFiles"), "*");
    if (fp.show() == nsIFilePicker.returnCancel)
      return;
    returnto.value = fp.file.path;
  }
  catch (ex)
  {
  }
}

function StreamPrint(strm, strng)
{
  strng += "\r\n";
  strm.write(strng, strng.length);
}

function GetVariableDescriptor(v, i)
{
  var vd = v[i].name;
  try
  {
    vd += "(" + v[i].units + ")";
  }
  catch (e)
  {
  }
  return vd;
}

function SaveCSV()
{
  if (window.waiting_sv_ready)
    return;
  var strb = document.getElementById("mozcellml-string-bundle");
  var filename = document.getElementById('csvfile').value;
  var file = Components.classes["@mozilla.org/file/local;1"]
                       .createInstance(Components.interfaces.nsILocalFile);
  try
  {
    file.initWithPath(filename);
  }
  catch (e)
  {
    var statusBar = document.getElementById('status-bar-display');
    statusBar.label = strb.getString("cantSaveToPath");
    return;
  }
  var stream = Components.classes["@mozilla.org/network/file-output-stream;1"]
                    .createInstance(Components.interfaces.nsIFileOutputStream);
  stream.init(
              file,
              /* PR_WRONLY | PR_CREATE_FILE | PR_TRUNCATE */
              42,
              /*0644*/420,
              0
             );
  var intg = window.arguments[0];
  var names = "";
  if (intg.nvariables == 0)
  {
    stream.close();
    return;
  }
  names += intg.bound + "(" + intg.boundunit + ")";
  for (i = 0; i < intg.nvariables; i++)
    names += "," + GetVariableDescriptor(intg.variables, i);
  StreamPrint(stream, names);
  var boundval = intg.startx;
  for (i = 0; i < intg.npoints; i++)
  {
    var values = boundval;
    boundval += intg.gridx;
    try
    {
      for (j = 0; j < intg.nvariables; j++)
        values += "," + window.zincFeeder.getValue(j, i);
      StreamPrint(stream, values);
    }
    catch (e)
    {
    }
  }
  stream.close();
  var statusBar = document.getElementById('status-bar-display');
  statusBar.label = strb.getString("csvExportComplete");
}

function make_graph_tab()
{
  var newidx = window.graphviews.length;
  var newid = window.max_graph_id++;
  var gv = new GraphView(newid);
  window.graphviews[newidx] = gv;

  var tp1 =
    document.getElementById("graph_tabpanels").getElementsByTagName("multitabpanel")
            .item(0).cloneNode(true);
  
  var gt = document.getElementById("graph_tabpanels");
  gt.appendChild(tp1);

  gv.setPanel(tp1);
  gv.setupTree(irw);

  var tab = document.createElement("multitab");
  tab.setAttribute("label", (newidx + 1));
  document.getElementById("graph_tabs").appendChild(tab);
  gv.tab = tab;
  tab.onscreen = true;

  gt.updatePanelLayout();
  gv.setPanel(tp1);
  gv.setupTree(irw);
  createScene(irw, newid);
  gv.irw = irw;
  SetupEmbed(gv, irw);
}

function close_graph_tab()
{
  if (graphviews.length == 1)
  {
    CancelIntegrationWindow();
    window.close();
    return;
  }

  var tb = document.getElementById("graph_tabbox");
  var delidx = tb.selectedIndex;
  var delgv = graphviews[delidx];
  var gt = document.getElementById("graph_tabpanels");
  gt.removeChild(delgv.panel);
  gt.updatePanelLayout();
  document.getElementById("graph_tabs").removeChild(delgv.tab);
  for (i = delidx; i < graphviews.length - 1; i++)
  {
    graphviews[i] = graphviews[i+1];
    graphviews[i].tab.setAttribute("label", (i + 1));
  }
  graphviews.pop();
  tb.selectedIndex = 0;
}
