#!/usr/bin/python
# Copyright (C) 2001-2002,  Christof Meerwald <cmeerw@web.de>
# http://xpcom2corba.sunsite.dk/

# XPCOM-CORBA is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; version 2 dated June, 1991.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
# 02111-1307, USA.

import sys, time, thread

from omniORB import CORBA

import CosNaming
import XPCOM
import Judo
import Jabber
import Jabber__POA


JABBER_SERVER = raw_input('Jabber server: ')
JABBER_USER = raw_input('Username: ')
JABBER_PASSWORD = raw_input('Password: ')


class Connect_Handler_i(Jabber__POA.SessionEvtConnected):
    def __init__(self, jab_session):
        self._jab_session = jab_session

    def onConnected(self, tag):
        print 'connected, id:', tag.getAttrib('id'), tag.toXML()

        my_presence = self._jab_session.createMyPresence(Jabber.Presence.ptAvailable, Jabber.Presence.stOnline, '', 0)
        self._jab_session.sendPacket(my_presence)


class Message_Handler_i(Jabber__POA.SessionEvtMessage):
    def __init__(self, jab_session):
        self._jab_session = jab_session

    def onMessage(self, message):
        print 'message', message._get_sender(), message._get_to(), message._get_body()
        #envelope = message.getExtension('envelope')
        #if envelope:
        #    print 'envelope from', envelope.getTag('from').getAttrib('jid')

        #delay = message.getExtension('delay')
        #if delay:
        #    print 'delay', delay.getAttrib('stamp')

        self._jab_session.sendPacket(message.reply('Hello world'))


orb = CORBA.ORB_init(sys.argv)
poa = orb.resolve_initial_references("RootPOA")

poaManager = poa._get_the_POAManager()
poaManager.activate()


nsctx = orb.resolve_initial_references('NameService')._narrow(CosNaming.NamingContextExt)
cman = nsctx.resolve_str('ComponentManager')._narrow(XPCOM.ComponentManager)

session = cman.create_instance('@JabXPCOM.sunsite.dk/Session;1')._narrow(Jabber.Session)
tcp_stream = cman.create_instance('@JabXPCOM.sunsite.dk/TcpStream;1')._narrow(Jabber.DataStream)

tcp_stream._narrow(Jabber.StreamClientConnector).connect_client(session._get_inputStream())
tcp_stream._narrow(Jabber.StreamOutputConnector).connect_output(JABBER_SERVER + ':5222', None)

session._set_outputStream(tcp_stream)

session.connectEvtConnected(Connect_Handler_i(session)._this())
session.connectEvtMessage(Message_Handler_i(session)._this())

session.connect(JABBER_SERVER, Jabber.Session.atDigestAuth,
                JABBER_USER, 'jabxpcom',
                JABBER_PASSWORD, 0)

orb.run()

session.disconnect()

session.release_ref()
