/*	-*- C++ -*-
 * Copyright (C) 2001,  Christof Meerwald <cmeerw@web.de>
 * http://xpcom2corba.sunsite.dk/
 */

/*
 * The contents of this file are subject to the Mozilla Public License
 * Version 1.1 (the "License"); you may not use this file except in
 * compliance with the License. You may obtain a copy of the License
 * at http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS"
 * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See
 * the License for the specific language governing rights and
 * limitations under the License.
 *
 * The Original Code is the XPCOM-CORBA Bridge package.
 *
 * The Initial Developer of the Original Code is Christof Meerwald.
 * Portions created by Christof Meerwald are Copyright (C) 2001
 * Christof Meerwald.  All Rights Reserved.
 *
 * Contributor(s): Christof Meerwald <cmeerw@web.de> (original author)
 */

#include <nsIGenericFactory.h>

#include "corba4xpcom_impl.h"
#include "corba_poa.h"


NS_GENERIC_FACTORY_CONSTRUCTOR(CORBA_ORBProxy_Impl)


static nsresult corbaModuleConstructor(nsIModule *self)
{
  static char *argv[] = { "corba_xpcommodule",
			  "-ORBendPoint", "giop:tcp:127.0.0.1:0",
#ifdef HIGH_ORBTRACELEVEL
                          "-ORBtraceLevel", "2000",
#endif
			  
                          NULL };

  CORBA_POA *my_corba_poa = new CORBA_POA();
  my_corba_poa->init(sizeof(argv) / sizeof(char *) - 1, argv);

  return NS_OK;
}


static nsModuleComponentInfo components[] =
{
  { "CORBA ORB Proxy", CORBA_ORBPROXY_CID, CORBA_ORBPROXY_CONTRACTID,
    CORBA_ORBProxy_ImplConstructor,
    NULL, NULL
  }
};


NS_IMPL_NSGETMODULE_WITH_CTOR("CORBA4XPCOM", components,
			      corbaModuleConstructor)
