/*	-*- C++ -*-
 * Copyright (C) 2001,  Christof Meerwald <cmeerw@web.de>
 * http://xpcom2corba.sunsite.dk/
 */

/*
 * The contents of this file are subject to the Mozilla Public License
 * Version 1.1 (the "License"); you may not use this file except in
 * compliance with the License. You may obtain a copy of the License
 * at http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS"
 * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See
 * the License for the specific language governing rights and
 * limitations under the License.
 *
 * The Original Code is the XPCOM-CORBA Bridge package.
 *
 * The Initial Developer of the Original Code is Christof Meerwald.
 * Portions created by Christof Meerwald are Copyright (C) 2001
 * Christof Meerwald.  All Rights Reserved.
 *
 * Contributor(s): Christof Meerwald <cmeerw@web.de> (original author)
 */
#ifndef HEADER__OBJECT_XPCOM__INCLUDED
#define HEADER__OBJECT_XPCOM__INCLUDED

#include "xpcorba_config.h"

#include <CORBA.h>
#include <nsISupports.h>

#include <xpcom.hh>


typedef nsISupports CORBA_IObject;

/**
 * XPCOM proxy for plain old CORBA objects.
 */
class CORBA_IObject__XPCOM_Proxy
  : public CORBA_IObject
{
 public:
  NS_DECL_ISUPPORTS
  NS_DEFINE_STATIC_IID_ACCESSOR(NS_ISUPPORTS_IID)

  explicit CORBA_IObject__XPCOM_Proxy(CORBA::Object_ptr corba_obj);
  CORBA_IObject__XPCOM_Proxy(CORBA::Object_ptr corba_obj, PRInt32 *ref_count);
  virtual ~CORBA_IObject__XPCOM_Proxy();


 private:
  CORBA::Object_var corba_obj_;
};


/**
 * XPCOM proxy for CORBA-wrapped XPCOM objects.
 */
class XPCOM_IObject__XPCOM_Proxy
  : public CORBA_IObject
{
 public:
  NS_DECL_ISUPPORTS
  NS_DEFINE_STATIC_IID_ACCESSOR(NS_ISUPPORTS_IID)

  explicit XPCOM_IObject__XPCOM_Proxy(XPCOM::IObject_ptr corba_obj);
  XPCOM_IObject__XPCOM_Proxy(XPCOM::IObject_ptr corba_obj, PRInt32 *ref_count);
  virtual ~XPCOM_IObject__XPCOM_Proxy();


 private:
  XPCOM::IObject_var corba_obj_;
  PRInt32 *ref_count_;
};

#endif
